<?php //Fichero creado por CGA cuyo origen es una modificacion del file.php
	  //que acompaña a moodle. Se ha deshabilitado la seguridad para los
	  //cursos de JCLIC

    require_once('config.php');
    require_once('lib/filelib.php');

    if (empty($CFG->filelifetime)) {
        $lifetime = 86400;     // Seconds for files to remain in caches
    } else {
        $lifetime = $CFG->filelifetime;
    }

    // disable moodle specific debug messages
    disable_debugging();

    $relativepath = get_file_argument('file_jclic.php');
    $forcedownload = optional_param('forcedownload', 0, PARAM_BOOL);
    
    // relative path must start with '/', because of backup/restore!!!
    if (!$relativepath) {
        error('No valid arguments supplied or incorrect server configuration');
    } else if ($relativepath{0} != '/') {
        error('No valid arguments supplied, path does not start with slash!');
    }

    $pathname = $CFG->dataroot.$relativepath;

    // extract relative path components
    $args = explode('/', trim($relativepath, '/'));
    if (count($args) == 0) { // always at least courseid, may search for index.html in course root
        error('No valid arguments supplied');
    }

    if (is_dir($pathname)) {
        if (file_exists($pathname.'/index.html')) {
            $pathname = rtrim($pathname, '/').'/index.html';
            $args[] = 'index.html';
        } else if (file_exists($pathname.'/index.htm')) {
            $pathname = rtrim($pathname, '/').'/index.htm';
            $args[] = 'index.htm';
        } else if (file_exists($pathname.'/Default.htm')) {
            $pathname = rtrim($pathname, '/').'/Default.htm';
            $args[] = 'Default.htm';
        } else {
            // security: do not return directory node!
            not_found($course->id);
        }
    }

    // check that file exists
    if (!file_exists($pathname)) {
        not_found($course->id);
    }

    // ========================================
    // finally send the file
    // ========================================
    session_write_close(); // unlock session during fileserving
    $filename = $args[count($args)-1];

	/*Comprobamos que el fichero es .ZIP y que dentro de este existe un fichero JCLIC*/
	$res = explode(".", $filename);

	if(strtolower($res[count($res)-1]) == 'zip' && strtolower($res[count($res)-2]) == 'jclic'){
		//Descomprimimos para saber si se trata de un modulo para jclic
		shell_exec("unzip /var/lib/moodle".$relativepath." -d /tmp/".$res[0].".".$res[1]);

		if(is_dir("/tmp/".$res[0].".".$res[1])){

			//Buscamos si existe algun fichero con extension JCLIC
			$dir = opendir("/tmp/".$res[0].".".$res[1]); 
			while ($file = readdir($dir)){
				if(preg_match("/(.*).\jclic/i", $file) && is_file("/tmp/".$res[0].".".$res[1]."/".$file)){				
					//Borro directorio
					shell_exec("rm -r /tmp/".$res[0].".".$res[1]);
					//Y habilito la lectura del fichero	
					send_file($pathname, $filename, $lifetime, $CFG->filteruploadedfiles, false, $forcedownload);
					return;
				}
			}
			closedir($dir); 

			not_found($course->id);
		}else{
			not_found($course->id);
		}

	}else{
		not_found($course->id);
	}

    function not_found($courseid) {
        global $CFG;
        header('HTTP/1.0 404 not found');
        error(get_string('filenotfound', 'error'), $CFG->wwwroot.'/course/view.php?id='.$courseid); //this is not displayed on IIS??
    }
?>
